<template>
  <div>
    <div class="padding-no-mobil">
      <div class="col text-center q-mb-md">
        <q-img class="width-logo-login" src="statics/images/media-logo.png" />
      </div>
      <div class="col label-title-login letras-system q-mb-xs">
        <label> ¡Bienvenido!</label>
      </div>
      <div class="col label-subtitle-login letras-system q-mb-lg">
        <label>Iniciar sesión </label>
      </div>
      <q-form @submit.prevent="login" @reset="reset">
        <div class="q-mt-xs q-mb-xs">
          <label class="label-formulario" for="Email (*)"> Email (*)</label>
          <q-input
            rounded
            v-validate="'required|email'"
            data-vv-as="email"
            name="email"
            type="text"
            :outlined="outlined"
            :dense="dense"
            v-model="credentials.email"
            :error-message="
              errors && errors['email']
                ? errors['email'][0]
                : '' || message || errorsvvalidate.first('email')
            "
            :error="
              errors['email'] || message || errorsvvalidate.first('email')
                ? true
                : false
            "
          >
            <template v-slot:prepend>
              <q-icon name="mail" />
            </template>
          </q-input>
        </div>

        <div class="q-mt-xs q-mb-xs">
          <label class="label-formulario" for="Contraseña (*)">
            Contraseña (*)</label
          >
          <q-input
            rounded
            v-validate="'required'"
            data-vv-as="contraseña"
            name="contraseña"
            :type="isPwd ? 'password' : 'text'"
            :outlined="outlined"
            :dense="dense"
            v-model="credentials.password"
            :error-message="
              errors && errors['contraseña']
                ? errors['contraseña'][0]
                : '' || errorsvvalidate.first('contraseña')
            "
            :error="
              errors['contraseña'] || errorsvvalidate.first('contraseña')
                ? true
                : false
            "
          >
            <template v-slot:prepend>
              <q-icon name="mdi-lock" />
            </template>
            <template v-slot:append>
              <q-icon
                :name="isPwd ? 'visibility_off' : 'visibility'"
                class="cursor-pointer"
                @click="isPwd = !isPwd"
              />
            </template>
          </q-input>
        </div>

        <div>
          <q-btn
            unelevated
            class="my-button-style-login q-mt-lg full-width"
            :loading="requestServer"
            label="Iniciar"
            type="submit"
            color="primary"
          />
        </div>
      </q-form>
    </div>
  </div>
</template>

<script>
import { mapActions } from "vuex";
import Input from "../../components/form/Input";
export default {
  components: {
    Input,
  },
  data() {
    return {
      isPwd: true,
      outlined: true,
      dense: true,
      credentials: {
        email: "",
        password: "",
      },
      requestServer: false,
      errors: {},
      message: "",
    };
  },
  methods: {
    login() {
      this.$validator.validate().then((valid) => {
        if (valid) {
          this.requestServer = true;
          this.$store
            .dispatch("user/loginAction", this.credentials)
            .then((success) => {})
            .catch((e) => {
              this.requestServer = false;
              if (e.response.status === 422) {
                this.errors = e.response.data.errors || {};
                this.message = "";
                return;
              }
              if (e.response.status === 401) {
                this.errors = {};
                this.message = e.response.data.error;
                return;
              }
            });
        } else {
          this.message = "";
          this.errors = {};
        }
      });
    },
    reset() {
      this.credentials = {
        email: "",
        password: "",
      };
      this.errors = {};
      this.message = "";
    },
  },
};
</script>
